#include "pt_blep.h"

#define LERP(I, F) (I[0] + F * (I[1] - I[0]))

static const unsigned int blepData[48] =
{
    0x3f7fe1f1,0x3f7fd548,0x3f7fd6a3,0x3f7fd4e3,0x3f7fad85,0x3f7f2152,0x3f7dbfae,0x3f7accdf,
    0x3f752f1e,0x3f6b7384,0x3f5bfbcb,0x3f455cf2,0x3f26e524,0x3f0128c4,0x3eacc7dc,0x3e29e86b,
    0x3c1c1d29,0xbde4bbe6,0xbe3aae04,0xbe48dedd,0xbe22ad7e,0xbdb2309a,0xbb82b620,0x3d881411,
    0x3ddadbf3,0x3de2c81d,0x3daaa01f,0x3d1e769a,0xbbc116d7,0xbd1402e8,0xbd38a069,0xbd0c53bb,
    0xbc3ffb8c,0x3c465fd2,0x3cea5764,0x3d0a51d6,0x3ceae2d5,0x3c92ac5a,0x3be4cbf7,0x00000000,
    0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000,0x00000000
};

void blepAdd(BLEP *b, float offset, float amplitude)
{
    const float *src;
    int n = NS;
    int i;
    float f;

    if (offset > 0.999999999f) // weird bugfix, TODO: Inspect
        return;

    i = (int)(offset * SP);
    src = ((const float *)blepData) + i + SP;
    f = offset * SP - i;
    i = b->index;

    while (n--)
    {
        b->buffer[i] += (amplitude * LERP(src, f));
        src += SP;
        i++;
        i &= RNS;
    }

    b->samplesLeft = NS;
}

float blepRun(BLEP *b)
{
    const float output = b->buffer[b->index];

    b->buffer[b->index] = 0.0f;
    b->index++;
    b->index &= RNS;
    b->samplesLeft--;

    return output;
}
