#ifndef __PT_BUTTONS_H
#define __PT_BUTTONS_H

#include <SDL/SDL.h>
#include "pt_header.h"

// taken from the ptplay project
enum ptbuttons
{
    // QUIT SCREEN
    PTB_SUREY,
    PTB_SUREN,

    // DISK OP SCREEN
    PTB_DO_FORMATDISK,
    PTB_DO_PACKMOD,
    PTB_DO_MODARROW,
    PTB_DO_LOADMODULE,
    PTB_DO_SAVEMODULE,
    PTB_DO_RENAMEFILE,
    PTB_DO_PACKSONG,
    PTB_DO_SONGARROW,
    PTB_DO_LOADSONG,
    PTB_DO_SAVESONG,
    PTB_DO_DELETEFILE,
    PTB_DO_SAMPLEFORMAT,
    PTB_DO_SAMPLEARROW,
    PTB_DO_LOADSAMPLE,
    PTB_DO_SAVESAMPLE,
    PTB_DO_TOGGLEPATH,
    PTB_DO_DATAPATH,
    PTB_DO_SWAPPAGE,
    PTB_DO_PARENT,
    PTB_DO_FREEMEM,
    PTB_DO_SCROLLTOP,
    PTB_DO_SCROLLUP,
    PTB_DO_EXIT,
    PTB_DO_SCROLLDOWN,
    PTB_DO_SCROLLBOT,
    PTB_DO_FILEAREA,

    // CLEAR
    PTB_CLEARSONG,
    PTB_CLEARSAMPLES,
    PTB_CLEARALL,
    PTB_CLEARCANCEL,

    // MAIN SCREEN
    PTB_QUIT,
    PTB_PLAY,
    PTB_PATTERN,
    PTB_EDIT,
    PTB_RECORD,
    PTB_STOP,
    PTB_CLEAR,
    PTB_EDITOP,
    PTB_DISKOP,
    PTB_PLST,
    PTB_PSETED,
    PTB_SETUP,
    PTB_SAMPLER,
    PTB_CHAN1,
    PTB_CHAN2,
    PTB_CHAN3,
    PTB_CHAN4,
    PTB_POSS,
    PTB_POSU,
    PTB_POSD,
    PTB_PATTERNS,
    PTB_PATTERNU,
    PTB_PATTERND,
    PTB_PLENGTHS,
    PTB_PLENGTHU,
    PTB_PLENGTHD,
    PTB_FTUNES,
    PTB_FTUNEU,
    PTB_FTUNED,
    PTB_SAMPLES,
    PTB_SAMPLEU,
    PTB_SAMPLED,
    PTB_SVOLUMES,
    PTB_SVOLUMEU,
    PTB_SVOLUMED,
    PTB_SLENGTHS,
    PTB_SLENGTHU,
    PTB_SLENGTHD,
    PTB_SREPEATS,
    PTB_SREPEATU,
    PTB_SREPEATD,
    PTB_SREPLENS,
    PTB_SREPLENU,
    PTB_SREPLEND,
    PTB_TEMPOU,
    PTB_TEMPOD,
    PTB_POSED,
    PTB_SONGNAME,
    PTB_SAMPLENAME,
    PTB_LOADSAMPLE,
    PTB_VISUALS,

    // SAMPLER SCREEN
    PTB_SA_EXIT,
    PTB_SA_PLAYWAVE,
    PTB_SA_SHOWRANGE,
    PTB_SA_ZOOMOUT,
    PTB_SA_STOP,
    PTB_SA_PLAYDISPLAYED,
    PTB_SA_SHOWALL,
    PTB_SA_RANGEALL,
    PTB_SA_LOOP,
    PTB_SA_PLAYRANGE,
    PTB_SA_RANGEBEG,
    PTB_SA_RANGEEND,
    PTB_SA_SWAPBUF,
    PTB_SA_SAMPLE,
    PTB_SA_SAMPLENOTE,
    PTB_SA_CUT,
    PTB_SA_COPY,
    PTB_SA_PASTE,
    PTB_SA_VOLUME,
    PTB_SA_TUNETONE,
    PTB_SA_RESAMPLE,
    PTB_SA_RESAMPLENOTE,
    PTB_SA_SAMPLEAREA,
    PTB_SA_ZOOMBARAREA,

    PTB_NUMBUTTONS
};

typedef struct
{
    int x1, y1, x2, y2, b;
} pt_button_s;

int checkGUIButtons(int mouseX, int mouseY);
void handleArrowKeys(SDLKey keyEntry, MODULE *modEntry);
void keyUpHandler(SDLKey keyEntry);
void keyDownHandler(SDLKey keyEntry, const SDL_Surface *screen, MODULE *modEntry);

#endif
