#ifndef __PT_HELPERS_H
#define __PT_HELPERS_H

#include <stdio.h>
#include "pt_header.h"

#ifdef _MSC_VER
#define inline __forceinline
#endif

#define HI_NYBBLE(x) ((x) >> 4)
#define LO_NYBBLE(x) ((x) & 0x0F)

#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) > (b)) ? (a) : (b))

#define ABS(a) (((a) < 0) ? -(a) : (a))
#define SGN(x) (((x) >= 0) ? 1 : -1)
#define CLAMP(x, low, high) (((x) > (high)) ? (high) : (((x) < (low)) ? (low) : (x)))

unsigned short fGetWordBigEndian(FILE *fileHandle);

int ptBMP2Header(const char *fileName);

void setPrevStatusMessage(void);
void setStatusMessage(const char *modEntrysg, int carry);

void calcRealModSize(MODULE *modEntry);

void createFrequencyTable(int soundFrequency, int baseClockRegion);

// in pt_modplayer.c
void clearSong(void);
void clearSamples(void);
void clearAll(void);
// -----------------

#endif
