#include "pt_palette.h"
#include "pt_helpers.h"

unsigned int palette[4] =
{
    COLOR_KEY,  // 00- PAL_COLORKEY
    0x00444444, // 01- PAL_POINTER_1
    0x00777777, // 02- PAL_POINTER_2
    0x00AAAAAA  // 03- PAL_POINTER_3
};

void pointerErrorMode(void)
{
    palette[PAL_POINTER_1] = 0x00770000;
    palette[PAL_POINTER_2] = 0x00990000;
    palette[PAL_POINTER_3] = 0x00CC0000;
}

void pointerSetMode(int pointerMode, int carry)
{
    if (input.mouse.buttonErrorMsgActive == true)
    {
        input.mouse.buttonErrorMsgActive = false;
        input.mouse.buttonWaitCounter = 0;

        setPrevStatusMessage();
    }

    switch (pointerMode)
    {
        case POINTER_MODE_IDLE:
        {
            editor.ui.pointerMode = pointerMode;

            if (carry == true)
            {
                editor.ui.previousPointerMode = editor.ui.pointerMode;
            }

            palette[PAL_POINTER_1] = 0x00444444;
            palette[PAL_POINTER_2] = 0x00777777;
            palette[PAL_POINTER_3] = 0x00AAAAAA;
        }
        break;

        case POINTER_MODE_PLAY:
        {
            editor.ui.pointerMode = pointerMode;

            if (carry == true)
            {
                editor.ui.previousPointerMode = editor.ui.pointerMode;
            }

            palette[PAL_POINTER_1] = 0x00444400;
            palette[PAL_POINTER_2] = 0x00777700;
            palette[PAL_POINTER_3] = 0x00AAAA00;
        }
        break;

        case POINTER_MODE_EDIT:
        {
            editor.ui.pointerMode = pointerMode;

            if (carry == true)
            {
                editor.ui.previousPointerMode = editor.ui.pointerMode;
            }

            palette[PAL_POINTER_1] = 0x00000066;
            palette[PAL_POINTER_2] = 0x00004499;
            palette[PAL_POINTER_3] = 0x000055BB;
        }
        break;

        case POINTER_MODE_EDIT_PLAY:
        {
            editor.ui.pointerMode = pointerMode;

            if (carry == true)
            {
                editor.ui.previousPointerMode = editor.ui.pointerMode;
            }

            palette[PAL_POINTER_1] = 0x00000066;
            palette[PAL_POINTER_2] = 0x00004499;
            palette[PAL_POINTER_3] = 0x000055BB;
        }
        break;

        case POINTER_MODE_MSG1:
        {
            editor.ui.pointerMode = pointerMode;

            if (carry == true)
            {
                editor.ui.previousPointerMode = editor.ui.pointerMode;
            }

            palette[PAL_POINTER_1] = 0x00440044;
            palette[PAL_POINTER_2] = 0x00770077;
            palette[PAL_POINTER_3] = 0x00AA00AA;
        }
        break;

        case POINTER_MODE_LOAD:
        {
            editor.ui.pointerMode = pointerMode;

            if (carry == true)
            {
                editor.ui.previousPointerMode = editor.ui.pointerMode;
            }
            
            palette[PAL_POINTER_1] = 0x00004400;
            palette[PAL_POINTER_2] = 0x00007700;
            palette[PAL_POINTER_3] = 0x0000AA00;
        }
        break;

        default:
        break;
    }
}

void pointerSetPreviousMode(void)
{
    pointerSetMode(editor.ui.previousPointerMode, false);
}
